Index: sasmodels/resolution.py
===================================================================
--- sasmodels/resolution.py	(revision 5258859dcf2d6cbd1ba2ea63ce85ff792c2056bb)
+++ sasmodels/resolution.py	(revision 5925e909151e120132e72e91095ab06bad045240)
@@ -5,4 +5,8 @@
 """
 from __future__ import division
+
+from scipy.special import erf
+from numpy import sqrt, log, log10
+import numpy as np
 
 __all__ = ["Resolution", "Perfect1D", "Pinhole1D", "Slit1D",
@@ -10,9 +14,5 @@
            "pinhole_extend_q", "slit_extend_q", "bin_edges",
            "interpolate", "linear_extrapolation", "geometric_extrapolation",
-           ]
-
-from scipy.special import erf
-from numpy import sqrt, log, log10
-import numpy as np
+          ]
 
 MINIMUM_RESOLUTION = 1e-8
@@ -80,8 +80,8 @@
         # default to Perfect1D if the pinhole geometry is not defined.
         self.q, self.q_width = q, q_width
-        self.q_calc = pinhole_extend_q(q, q_width, nsigma=nsigma) \
-            if q_calc is None else np.sort(q_calc)
-        self.weight_matrix = pinhole_resolution(self.q_calc,
-                self.q, np.maximum(q_width, MINIMUM_RESOLUTION))
+        self.q_calc = (pinhole_extend_q(q, q_width, nsigma=nsigma)
+                       if q_calc is None else np.sort(q_calc))
+        self.weight_matrix = pinhole_resolution(
+            self.q_calc, self.q, np.maximum(q_width, MINIMUM_RESOLUTION))
 
     def apply(self, theory):
@@ -135,5 +135,5 @@
     """
     #print("apply shapes", theory.shape, weight_matrix.shape)
-    Iq = np.dot(theory[None,:], weight_matrix)
+    Iq = np.dot(theory[None, :], weight_matrix)
     #print("result shape",Iq.shape)
     return Iq.flatten()
@@ -153,8 +153,8 @@
     # neither trapezoid nor Simpson's rule improved the accuracy.
     edges = bin_edges(q_calc)
-    edges[edges<0.0] = 0.0 # clip edges below zero
-    G = erf( (edges[:,None] - q[None,:]) / (sqrt(2.0)*q_width)[None,:] )
+    edges[edges < 0.0] = 0.0 # clip edges below zero
+    G = erf((edges[:, None] - q[None, :]) / (sqrt(2.0)*q_width)[None, :])
     weights = G[1:] - G[:-1]
-    weights /= np.sum(weights, axis=0)[None,:]
+    weights /= np.sum(weights, axis=0)[None, :]
     return weights
 
@@ -287,5 +287,5 @@
     # The current algorithm is a midpoint rectangle rule.
     q_edges = bin_edges(q_calc) # Note: requires q > 0
-    q_edges[q_edges<0.0] = 0.0 # clip edges below zero
+    q_edges[q_edges < 0.0] = 0.0 # clip edges below zero
     weights = np.zeros((len(q), len(q_calc)), 'd')
 
@@ -306,10 +306,10 @@
             #print(qi - h, qi + h)
             #print(in_x + abs_x)
-            weights[i,:] = (in_x + abs_x) * np.diff(q_edges) / (2*h)
+            weights[i, :] = (in_x + abs_x) * np.diff(q_edges) / (2*h)
         else:
             L = n_height
             for k in range(-L, L+1):
-                weights[i,:] += _q_perp_weights(q_edges, qi+k*h/L, w)
-            weights[i,:] /= 2*L + 1
+                weights[i, :] += _q_perp_weights(q_edges, qi+k*h/L, w)
+            weights[i, :] /= 2*L + 1
 
     return weights.T
@@ -358,5 +358,5 @@
     log-scaled data.
     """
-    if len(x) < 2 or (np.diff(x)<0).any():
+    if len(x) < 2 or (np.diff(x) < 0).any():
         raise ValueError("Expected bins to be an increasing set")
     edges = np.hstack([
@@ -373,13 +373,13 @@
     """
     step = np.diff(q)
-    index = step>max_step
+    index = step > max_step
     if np.any(index):
         inserts = []
-        for q_i,step_i in zip(q[:-1][index],step[index]):
+        for q_i, step_i in zip(q[:-1][index], step[index]):
             n = np.ceil(step_i/max_step)
-            inserts.extend(q_i + np.arange(1,n)*(step_i/n))
+            inserts.extend(q_i + np.arange(1, n)*(step_i/n))
         # Extend a couple of fringes beyond the end of the data
-        inserts.extend(q[-1] + np.arange(1,8)*max_step)
-        q_calc = np.sort(np.hstack((q,inserts)))
+        inserts.extend(q[-1] + np.arange(1, 8)*max_step)
+        q_calc = np.sort(np.hstack((q, inserts)))
     else:
         q_calc = q
@@ -399,10 +399,10 @@
     if q_min < q[0]:
         if q_min <= 0: q_min = q_min*MIN_Q_SCALE_FOR_NEGATIVE_Q_EXTRAPOLATION
-        n_low = np.ceil((q[0]-q_min) / (q[1]-q[0])) if q[1]>q[0] else 15
+        n_low = np.ceil((q[0]-q_min) / (q[1]-q[0])) if q[1] > q[0] else 15
         q_low = np.linspace(q_min, q[0], n_low+1)[:-1]
     else:
         q_low = []
     if q_max > q[-1]:
-        n_high = np.ceil((q_max-q[-1]) / (q[-1]-q[-2])) if q[-1]>q[-2] else 15
+        n_high = np.ceil((q_max-q[-1]) / (q[-1]-q[-2])) if q[-1] > q[-2] else 15
         q_high = np.linspace(q[-1], q_max, n_high+1)[1:]
     else:
@@ -452,5 +452,5 @@
         if q_min < 0: q_min = q[0]*MIN_Q_SCALE_FOR_NEGATIVE_Q_EXTRAPOLATION
         n_low = log_delta_q * (log(q[0])-log(q_min))
-        q_low  = np.logspace(log10(q_min), log10(q[0]), np.ceil(n_low)+1)[:-1]
+        q_low = np.logspace(log10(q_min), log10(q[0]), np.ceil(n_low)+1)[:-1]
     else:
         q_low = []
@@ -470,4 +470,11 @@
 
 def eval_form(q, form, pars):
+    """
+    Return the SAS model evaluated at *q*.
+
+    *form* is the SAS model returned from :fun:`core.load_model`.
+
+    *pars* are the parameter values to use when evaluating.
+    """
     from sasmodels import core
     kernel = core.make_kernel(form, [q])
@@ -478,4 +485,9 @@
 
 def gaussian(q, q0, dq):
+    """
+    Return the Gaussian resolution function.
+
+    *q0* is the center, *dq* is the width and *q* are the points to evaluate.
+    """
     from numpy import exp, pi
     return exp(-0.5*((q-q0)/dq)**2)/(sqrt(2*pi)*dq)
@@ -489,5 +501,5 @@
     that make it slow to evaluate but give it good accuracy.
     """
-    from scipy.integrate import romberg, dblquad
+    from scipy.integrate import romberg
 
     if any(k not in form.info['defaults'] for k in pars.keys()):
@@ -520,16 +532,15 @@
             result[i] = r/(2*h)
         else:
-            w_grid = np.linspace(0, w, 21)[None,:]
-            h_grid = np.linspace(-h, h, 23)[:,None]
+            w_grid = np.linspace(0, w, 21)[None, :]
+            h_grid = np.linspace(-h, h, 23)[:, None]
             u = sqrt((qi+h_grid)**2 + w_grid**2)
             Iu = np.interp(u, q_calc, Iq)
             #print(np.trapz(Iu, w_grid, axis=1))
-            Is = np.trapz(np.trapz(Iu, w_grid, axis=1), h_grid[:,0])
+            Is = np.trapz(np.trapz(Iu, w_grid, axis=1), h_grid[:, 0])
             result[i] = Is / (2*h*w)
-            """
-            r, err = dblquad(_int_wh, -h, h, lambda h: 0., lambda h: w,
-                             args=(qi,))
-            result[i] = r/(w*2*h)
-            """
+            # from scipy.integrate import dblquad
+            # r, err = dblquad(_int_wh, -h, h, lambda h: 0., lambda h: w,
+            #                  args=(qi,))
+            # result[i] = r/(w*2*h)
 
     # r should be [float, ...], but it is [array([float]), array([float]),...]
@@ -553,11 +564,14 @@
 
     _fn = lambda q, q0, dq: eval_form(q, form, pars)*gaussian(q, q0, dq)
-    r = [romberg(_fn, max(qi-nsigma*dqi,1e-10*q[0]), qi+nsigma*dqi, args=(qi, dqi),
-                 divmax=100, vec_func=True, tol=0, rtol=1e-8)
-         for qi,dqi in zip(q,q_width)]
+    r = [romberg(_fn, max(qi-nsigma*dqi, 1e-10*q[0]), qi+nsigma*dqi,
+                 args=(qi, dqi), divmax=100, vec_func=True, tol=0, rtol=1e-8)
+         for qi, dqi in zip(q, q_width)]
     return np.asarray(r).flatten()
 
 
 class ResolutionTest(unittest.TestCase):
+    """
+    Test the resolution calculations.
+    """
 
     def setUp(self):
@@ -595,6 +609,8 @@
         theory = self.Iq(resolution.q_calc)
         output = resolution.apply(theory)
-        answer = [ 9.0618, 8.6402, 8.1187, 7.1392, 6.1528,
-                   5.5555, 4.5584, 3.5606, 2.5623, 2.0000 ]
+        answer = [
+            9.0618, 8.6402, 8.1187, 7.1392, 6.1528,
+            5.5555, 4.5584, 3.5606, 2.5623, 2.0000,
+            ]
         np.testing.assert_allclose(output, answer, atol=1e-4)
 
@@ -608,6 +624,8 @@
         theory = 1000*self.Iq(resolution.q_calc**4)
         output = resolution.apply(theory)
-        answer = [ 8.85785, 8.43012, 7.92687, 6.94566, 6.03660,
-                   5.40363, 4.40655, 3.40880, 2.41058, 2.00000 ]
+        answer = [
+            8.85785, 8.43012, 7.92687, 6.94566, 6.03660,
+            5.40363, 4.40655, 3.40880, 2.41058, 2.00000,
+            ]
         np.testing.assert_allclose(output, answer, atol=1e-4)
 
@@ -620,5 +638,7 @@
         theory = self.Iq(resolution.q_calc)
         output = resolution.apply(theory)
-        answer = [ 11.0, 10.0, 9.0, 8.0, 7.0, 6.0, 5.0, 4.0, 3.0, 2.0 ]
+        answer = [
+            11.0, 10.0, 9.0, 8.0, 7.0, 6.0, 5.0, 4.0, 3.0, 2.0,
+            ]
         np.testing.assert_allclose(output, answer, atol=1e-4)
 
@@ -632,5 +652,7 @@
         theory = self.Iq(resolution.q_calc)
         output = resolution.apply(theory)
-        answer = [ 11.0, 10.0, 9.0, 8.0, 7.0, 6.0, 5.0, 4.0, 3.0, 2.0 ]
+        answer = [
+            11.0, 10.0, 9.0, 8.0, 7.0, 6.0, 5.0, 4.0, 3.0, 2.0,
+            ]
         np.testing.assert_allclose(output, answer, atol=1e-4)
 
@@ -652,11 +674,16 @@
         theory = 12.0-1000.0*resolution.q_calc
         output = resolution.apply(theory)
-        answer = [ 10.44785079, 9.84991299, 8.98101708,
-                  7.99906585, 6.99998311, 6.00001689,
-                  5.00093415, 4.01898292, 3.15008701, 2.55214921]
+        answer = [
+            10.44785079, 9.84991299, 8.98101708,
+            7.99906585, 6.99998311, 6.00001689,
+            5.00093415, 4.01898292, 3.15008701, 2.55214921,
+            ]
         np.testing.assert_allclose(output, answer, atol=1e-8)
 
 
 class IgorComparisonTest(unittest.TestCase):
+    """
+    Test resolution calculations against those returned by Igor.
+    """
 
     def setUp(self):
@@ -666,5 +693,5 @@
         self.model = core.load_model(sphere, dtype='double')
 
-    def Iq_sphere(self, pars, resolution):
+    def _eval_sphere(self, pars, resolution):
         from sasmodels import core
         kernel = core.make_kernel(self.model, [resolution.q_calc])
@@ -674,5 +701,5 @@
         return result
 
-    def compare(self, q, output, answer, tolerance):
+    def _compare(self, q, output, answer, tolerance):
         #err = (output - answer)/answer
         #idx = abs(err) >= tolerance
@@ -691,6 +718,6 @@
         q, width, answer, _ = data
         resolution = Perfect1D(q)
-        output = self.Iq_sphere(pars, resolution)
-        self.compare(q, output, answer, 1e-6)
+        output = self._eval_sphere(pars, resolution)
+        self._compare(q, output, answer, 1e-6)
 
     def test_pinhole(self):
@@ -704,7 +731,7 @@
         q, q_width, answer = data
         resolution = Pinhole1D(q, q_width)
-        output = self.Iq_sphere(pars, resolution)
+        output = self._eval_sphere(pars, resolution)
         # TODO: relative error should be lower
-        self.compare(q, output, answer, 3e-4)
+        self._compare(q, output, answer, 3e-4)
 
     def test_pinhole_romberg(self):
@@ -727,14 +754,14 @@
         q_calc, tol = None, 0.01
         resolution = Pinhole1D(q, q_width, q_calc=q_calc)
-        output = self.Iq_sphere(pars, resolution)
+        output = self._eval_sphere(pars, resolution)
         if 0: # debug plot
             import matplotlib.pyplot as plt
             resolution = Perfect1D(q)
-            source = self.Iq_sphere(pars, resolution)
+            source = self._eval_sphere(pars, resolution)
             plt.loglog(q, source, '.')
             plt.loglog(q, answer, '-', hold=True)
             plt.loglog(q, output, '-', hold=True)
             plt.show()
-        self.compare(q, output, answer, tol)
+        self._compare(q, output, answer, tol)
 
     def test_slit(self):
@@ -748,9 +775,9 @@
         q, delta_qv, _, answer = data
         resolution = Slit1D(q, width=delta_qv, height=0)
-        output = self.Iq_sphere(pars, resolution)
+        output = self._eval_sphere(pars, resolution)
         # TODO: eliminate Igor test since it is too inaccurate to be useful.
         # This means we can eliminate the test data as well, and instead
         # use a generated q vector.
-        self.compare(q, output, answer, 0.5)
+        self._compare(q, output, answer, 0.5)
 
     def test_slit_romberg(self):
@@ -768,7 +795,7 @@
                                delta_qv[0], 0.)
         resolution = Slit1D(q, width=delta_qv, height=0, q_calc=q_calc)
-        output = self.Iq_sphere(pars, resolution)
+        output = self._eval_sphere(pars, resolution)
         # TODO: relative error should be lower
-        self.compare(q, output, answer, 0.025)
+        self._compare(q, output, answer, 0.025)
 
     def test_ellipsoid(self):
@@ -783,5 +810,5 @@
             }
         form = load_model('ellipsoid', dtype='double')
-        q = np.logspace(log10(4e-5),log10(2.5e-2), 68)
+        q = np.logspace(log10(4e-5), log10(2.5e-2), 68)
         width, height = 0.117, 0.
         resolution = Slit1D(q, width=width, height=height)
@@ -790,5 +817,5 @@
         # TODO: 10% is too much error; use better algorithm
         #print(np.max(abs(answer-output)/answer))
-        self.compare(q, output, answer, 0.1)
+        self._compare(q, output, answer, 0.1)
 
     #TODO: can sas q spacing be too sparse for the resolution calculation?
@@ -804,6 +831,6 @@
         q, q_width, answer = data[:, ::20] # Take every nth point
         resolution = Pinhole1D(q, q_width)
-        output = self.Iq_sphere(pars, resolution)
-        self.compare(q, output, answer, 1e-6)
+        output = self._eval_sphere(pars, resolution)
+        self._compare(q, output, answer, 1e-6)
 
 
@@ -1058,4 +1085,7 @@
 
 def demo_pinhole_1d():
+    """
+    Show example of pinhole smearing.
+    """
     q = np.logspace(-4, np.log10(0.2), 400)
     q_width = 0.1*q
@@ -1064,4 +1094,7 @@
 
 def demo_slit_1d():
+    """
+    Show example of slit smearing.
+    """
     q = np.logspace(-4, np.log10(0.2), 100)
     w = h = 0.
@@ -1071,7 +1104,10 @@
     #h = 0.0277790
     resolution = Slit1D(q, w, h)
-    _eval_demo_1d(resolution, title="(%g,%g) Slit Resolution"%(w,h))
+    _eval_demo_1d(resolution, title="(%g,%g) Slit Resolution"%(w, h))
 
 def demo():
+    """
+    Run the resolution demos.
+    """
     import matplotlib.pyplot as plt
     plt.subplot(121)
Index: sasmodels/resolution2d.py
===================================================================
--- sasmodels/resolution2d.py	(revision 9404dd3f599fcbe72790aae8a6d176e64f292ea6)
+++ sasmodels/resolution2d.py	(revision 823e6204f35d6c2bf32f27a3a3c137a369a973cf)
@@ -2,5 +2,5 @@
 #This software was developed by the University of Tennessee as part of the
 #Distributed Data Analysis of Neutron Scattering Experiments (DANSE)
-#project funded by the US National Science Foundation. 
+#project funded by the US National Science Foundation.
 #See the license text in license.txt
 """
@@ -19,5 +19,5 @@
 ## Defaults
 NR = {'xhigh':10, 'high':5, 'med':5, 'low':3}
-NPHI ={'xhigh':20, 'high':12, 'med':6, 'low':4}
+NPHI = {'xhigh':20, 'high':12, 'med':6, 'low':4}
 
 class Pinhole2D(Resolution):
@@ -25,10 +25,10 @@
     Gaussian Q smearing class for SAS 2d data
     """
-     
+
     def __init__(self, data=None, index=None,
                  nsigma=NSIGMA, accuracy='Low', coords='polar'):
         """
         Assumption: equally spaced bins in dq_r, dq_phi space.
-        
+
         :param data: 2d data used to set the smearing parameters
         :param index: 1d array with len(data) to define the range
@@ -42,8 +42,8 @@
         ## number of bins in r axis for over-sampling
         self.nr = NR[accuracy.lower()]
-        ## number of bins in phi axis for over-sampling 
+        ## number of bins in phi axis for over-sampling
         self.nphi = NPHI[accuracy.lower()]
         ## maximum nsigmas
-        self.nsigma= nsigma
+        self.nsigma = nsigma
         self.coords = coords
         self._init_data(data, index)
@@ -85,7 +85,7 @@
     def _calc_res(self):
         """
-        Over sampling of r_nbins times phi_nbins, calculate Gaussian weights, 
+        Over sampling of r_nbins times phi_nbins, calculate Gaussian weights,
         then find smeared intensity
-        """    
+        """
         nr, nphi = self.nr, self.nphi
         # Total number of bins = # of bins
@@ -143,11 +143,11 @@
         if self.coords == 'polar':
             q_r = sqrt(qx**2 + qy**2)
-            qx_res = ( (dqx*cos(dphi) + q_r) * cos(-q_phi) +
-                           dqy*sin(dphi) * sin(-q_phi))
-            qy_res = (-(dqx*cos(dphi) + q_r) * sin(-q_phi) +
-                           dqy*sin(dphi) * cos(-q_phi))
+            qx_res = ((dqx*cos(dphi) + q_r) * cos(-q_phi)
+                      + dqy*sin(dphi) * sin(-q_phi))
+            qy_res = (-(dqx*cos(dphi) + q_r) * sin(-q_phi)
+                      + dqy*sin(dphi) * cos(-q_phi))
         else:
-            qx_res = qx +  dqx*cos(dphi)
-            qy_res = qy +  dqy*sin(dphi)
+            qx_res = qx + dqx*cos(dphi)
+            qy_res = qy + dqy*sin(dphi)
 
 
@@ -162,75 +162,7 @@
             theory = np.reshape(theory, (nbins, nq))
             ## Averaging with Gaussian weighting: normalization included.
-            value =np.average(theory, axis=0, weights=self.q_calc_weights)
+            value = np.average(theory, axis=0, weights=self.q_calc_weights)
             ## Return the smeared values in the range of self.index
             return value
         else:
             return theory
-
-"""
-if __name__ == '__main__':
-    ## Test w/ 2D linear function
-    x = 0.001*np.arange(1, 11)
-    dx = np.ones(len(x))*0.0003
-    y = 0.001*np.arange(1, 11)
-    dy = np.ones(len(x))*0.001
-    z = np.ones(10)
-    dz = sqrt(z)
-
-    from sas.dataloader import Data2D
-    #for i in range(10): print(i, 0.001 + i*0.008/9.0)
-    #for i in range(100): print(i, int(math.floor( (i/ (100/9.0)) )))
-    out = Data2D()
-    out.data = z
-    out.qx_data = x
-    out.qy_data = y
-    out.dqx_data = dx
-    out.dqy_data = dy
-    out.q_data = sqrt(dx * dx + dy * dy)
-    index = np.ones(len(x), dtype = bool)
-    out.mask = index
-    from sas.models.LineModel import LineModel
-    model = LineModel()
-    model.setParam("A", 0)
-
-    smear = Smearer2D(out, model, index)
-    #smear.set_accuracy('Xhigh')
-    value = smear.get_value()
-    ## All data are ones, so the smeared should also be ones.
-    print("Data length =", len(value))
-    print(" 2D linear function, I = 0 + 1*qy")
-    text = " Gaussian weighted averaging on a 2D linear function will "
-    text += "provides the results same as without the averaging."
-    print(text)
-    print("qx_data", "qy_data", "I_nonsmear", "I_smeared")
-    for ind in range(len(value)):
-        print(x[ind], y[ind], model.evalDistribution([x, y])[ind], value[ind])
-
-
-if __name__ == '__main__':
-    ## Another Test w/ constant function
-    x = 0.001*np.arange(1,11)
-    dx = np.ones(len(x))*0.001
-    y = 0.001*np.arange(1,11)
-    dy = np.ones(len(x))*0.001
-    z = np.ones(10)
-    dz = sqrt(z)
-
-    from DataLoader import Data2D
-    #for i in range(10): print(i, 0.001 + i*0.008/9.0)
-    #for i in range(100): print(i, int(math.floor( (i/ (100/9.0)) )))
-    out = Data2D()
-    out.data = z
-    out.qx_data = x
-    out.qy_data = y
-    out.dqx_data = dx
-    out.dqy_data = dy
-    index = np.ones(len(x), dtype = bool)
-    out.mask = index
-    from sas.models.Constant import Constant
-    model = Constant()
-
-    value = Smearer2D(out,model,index).get_value()
-    ## All data are ones, so the smeared values should also be ones.
-    print("Data length =",len(value), ", Data=",value)
-"""
Index: sasmodels/sasview_model.py
===================================================================
--- sasmodels/sasview_model.py	(revision 9404dd3f599fcbe72790aae8a6d176e64f292ea6)
+++ sasmodels/sasview_model.py	(revision eafc9fa8b200a3b754e7dafb960c8891361eacef)
@@ -283,5 +283,5 @@
         """
         q_vectors = [np.asarray(q) for q in args]
-        fn = self._model(self._model.make_input(q_vectors))
+        fn = self._model(q_vectors)
         pars = [self.params[v] for v in fn.fixed_pars]
         pd_pars = [self._get_weights(p) for p in fn.pd_pars]
Index: sasmodels/sesans.py
===================================================================
--- sasmodels/sesans.py	(revision 3c56da87f0995bdde77f4183b68e77b81584dde0)
+++ sasmodels/sesans.py	(revision 190fc2b167d3d89ca9c3b7d3128bdf8bde9f67d0)
@@ -12,40 +12,25 @@
 import numpy as np
 from numpy import pi, exp
-
 from scipy.special import jv as besselj
 
-def make_q(q_zmax, Rmax):
+def make_q(q_max, Rmax):
+    r"""
+    Return a $q$ vector suitable for SESANS covering from $2\pi/ (10 R_{\max})$
+    to $q_max$.
+    """
     q_min = dq = 0.1 * 2*pi / Rmax
-    #q_min = 0.00003
-    return np.arange(q_min, q_zmax, dq)
-
-# TODO: dead code; for now the call to the hankel transform happens in BumpsModel
-class SesansCalculator:
-    def __init__(self, kernel, q_zmax, Rmax, SElength, wavelength, thickness):
-        self._set_kernel(kernel, q_zmax, Rmax)
-        self.SElength = SElength
-        self.wavelength = wavelength
-        self.thickness = thickness
-
-    def _set_kernel(self, kernel, q_zmax, Rmax):
-        kernel_input = kernel.make_input([make_q(q_zmax, Rmax)])
-        self.sans_calculator = kernel(kernel_input)
-
-    def __call__(self, pars, pd_pars, cutoff=1e-5):
-        Iq = self.sans_calculator(pars, pd_pars, cutoff)
-        P = hankel(self.SElength, self.wavelength, self.thickness, self.q, Iq)
-        self.Iq = Iq
-        return P
+    return np.arange(q_min, q_max, dq)
 
 def hankel(SElength, wavelength, thickness, q, Iq):
-    """
+    r"""
     Compute the expected SESANS polarization for a given SANS pattern.
 
-    Uses the hankel transform followed by the exponential.  The values
-    for zz (or spin echo length, or delta), wavelength and sample thickness
-    information should come from the dataset.  *q* should be chosen such
-    that the oscillations in *I(q)* are well sampled (e.g., 5*2*pi/d_max).
+    Uses the hankel transform followed by the exponential.  The values for *zz*
+    (or spin echo length, or delta), wavelength and sample thickness should
+    come from the dataset.  $q$ should be chosen such that the oscillations
+    in $I(q)$ are well sampled (e.g., $5 \cdot 2 \pi/d_{\max}$).
 
-    *SElength* [A] is the set of z points at which to compute the hankel transform
+    *SElength* [A] is the set of $z$ points at which to compute the
+    Hankel transform
 
     *wavelength* [m]  is the wavelength of each individual point *zz*
@@ -53,15 +38,20 @@
     *thickness* [cm] is the sample thickness.
 
-    *q* [A^{-1}] is the set of q points at which the model has been computed.
-    These should be equally spaced.
+    *q* [A$^{-1}$] is the set of $q$ points at which the model has been
+    computed. These should be equally spaced.
 
-    *I* [cm^{-1}] is the value of the SANS model at *q*
+    *I* [cm$^{-1}$] is the value of the SANS model at *q*
     """
-    G = np.zeros(len(SElength), 'd')
-    for i in range(len(SElength)):
-        integr = besselj(0,q*SElength[i])*Iq*q
-        G[i] = np.sum(integr)
-    dq=(q[1]-q[0])*1e10   # [m^-1] step size in q, needed for integration
-    G *= dq*1e10*2*pi # integr step, conver q into [m**-1] and 2 pi circle integr
+    G = np.zeros_like(SElength, 'd')
+    for i, SElength_i in enumerate(SElength):
+        integral = besselj(0, q*SElength_i)*Iq*q
+        G[i] = np.sum(integral)
+
+    # [m^-1] step size in q, needed for integration
+    dq = (q[1]-q[0])*1e10
+
+    # integration step, convert q into [m**-1] and 2 pi circle integration
+    G *= dq*1e10*2*pi
+
     P = exp(thickness*wavelength**2/(4*pi**2)*(G-G[0]))
 
Index: sasmodels/weights.py
===================================================================
--- sasmodels/weights.py	(revision 3c56da87f0995bdde77f4183b68e77b81584dde0)
+++ sasmodels/weights.py	(revision 5c962dff13d0a0a2f6d779be8df775f540958dbc)
@@ -22,4 +22,7 @@
 
     def get_pars(self):
+        """
+        Return the parameters to the disperser as a dictionary.
+        """
         pars = {'type': self.type}
         pars.update(self.__dict__)
@@ -28,4 +31,7 @@
     # pylint: disable=no-self-use
     def set_weights(self, values, weights):
+        """
+        Set the weights on the disperser if it is :class:`ArrayDispersion`.
+        """
         raise RuntimeError("set_weights is only available for ArrayDispersion")
 
@@ -36,5 +42,5 @@
         *center* is the center of the distribution
 
-        *lb*,*ub* are the min and max allowed values
+        *lb*, *ub* are the min and max allowed values
 
         *relative* is True if the distribution width is proportional to the
@@ -63,4 +69,11 @@
 
 class GaussianDispersion(Dispersion):
+    r"""
+    Gaussian dispersion, with 1-\ $\sigma$ width.
+
+    .. math::
+
+        w = \exp\left(-\tfrac12 (x - c)^2/\sigma^2\right)
+    """
     type = "gaussian"
     default = dict(npts=35, width=0, nsigmas=3)
@@ -72,4 +85,11 @@
 
 class RectangleDispersion(Dispersion):
+    r"""
+    Uniform dispersion, with width $\sqrt{3}\sigma$.
+
+    .. math::
+
+        w = 1
+    """
     type = "rectangle"
     default = dict(npts=35, width=0, nsigmas=1.70325)
@@ -81,18 +101,40 @@
 
 class LogNormalDispersion(Dispersion):
+    r"""
+    log Gaussian dispersion, with 1-\ $\sigma$ width.
+
+    .. math::
+
+        w = \frac{\exp\left(-\tfrac12 (\ln x - c)^2/\sigma^2\right)}{x\sigma}
+    """
     type = "lognormal"
     default = dict(npts=80, width=0, nsigmas=8)
     def _weights(self, center, sigma, lb, ub):
-        x = self._linspace(center, sigma, max(lb,1e-8), max(ub,1e-8))
-        px = np.exp(-0.5*(np.log(x)-center)**2)/sigma**2/(x*sigma)
+        x = self._linspace(center, sigma, max(lb, 1e-8), max(ub, 1e-8))
+        px = np.exp(-0.5*(np.log(x)-center)**2/sigma**2)/(x*sigma)
         return x, px
 
 
 class SchulzDispersion(Dispersion):
+    r"""
+    Schultz dispersion, with 1-\ $\sigma$ width.
+
+    .. math::
+
+        w = \frac{z^z\,R^{z-1}}{e^{Rz}\,c \Gamma(z)}
+
+    where $c$ is the center of the distribution, $R = x/c$ and $z=(c/\sigma)^2$.
+
+    This is evaluated using logarithms as
+
+    .. math::
+
+        w = \exp\left(z \ln z + (z-1)\ln R - Rz - \ln c - \ln \Gamma(z) \right)
+    """
     type = "schulz"
     default = dict(npts=80, width=0, nsigmas=8)
     def _weights(self, center, sigma, lb, ub):
-        x = self._linspace(center, sigma, max(lb,1e-8), max(ub,1e-8))
-        R= x/center
+        x = self._linspace(center, sigma, max(lb, 1e-8), max(ub, 1e-8))
+        R = x/center
         z = (center/sigma)**2
         arg = z*np.log(z) + (z-1)*np.log(R) - R*z - np.log(center) - gammaln(z)
@@ -102,4 +144,9 @@
 
 class ArrayDispersion(Dispersion):
+    r"""
+    Empirical dispersion curve.
+
+    Use :meth:`set_weights` to set $w = f(x)$.
+    """
     type = "array"
     default = dict(npts=35, width=0, nsigmas=1)
@@ -110,4 +157,7 @@
 
     def set_weights(self, values, weights):
+        """
+        Set the weights for the given x values.
+        """
         self.values = np.ascontiguousarray(values, 'd')
         self.weights = np.ascontiguousarray(weights, 'd')
@@ -117,5 +167,5 @@
         # TODO: interpolate into the array dispersion using npts
         x = center + self.values*sigma
-        idx = (x>=lb)&(x<=ub)
+        idx = (x >= lb) & (x <= ub)
         x = x[idx]
         px = self.weights[idx]
@@ -124,5 +174,5 @@
 
 # dispersion name -> disperser lookup table.
-models = dict((d.type,d) for d in (
+models = dict((d.type, d) for d in (
     GaussianDispersion, RectangleDispersion,
     ArrayDispersion, SchulzDispersion, LogNormalDispersion
@@ -149,13 +199,13 @@
     of the parameter, and false if it is an absolute width.
 
-    Returns *(value,weight)*, where *value* and *weight* are vectors.
+    Returns *(value, weight)*, where *value* and *weight* are vectors.
     """
     cls = models[disperser]
     obj = cls(n, width, nsigmas)
-    v,w = obj.get_weights(value, limits[0], limits[1], relative)
-    return v,w
+    v, w = obj.get_weights(value, limits[0], limits[1], relative)
+    return v, w
 
 # Hack to allow sasview dispersion objects to interoperate with sasmodels
-dispersers = dict((v.__name__,k) for k,v in models.items())
+dispersers = dict((v.__name__, k) for k, v in models.items())
 dispersers['DispersionModel'] = RectangleDispersion.type
 
